/*--------------------------------*- C++ -*----------------------------------*\
  ==  == ====== ====   ====    |
                    \\     ||  | HZDR Multiphase Case Collection for OpenFOAM
  ======   //   ||  || ===//   | Website: https://doi.org/10.14278/rodare.812
  ||  ||  //    ||  // || \\   | License: Creative Commons Attribution 4.0
  ==  == ====== ====   ==  ==  |
\*---------------------------------------------------------------------------*/
FoamFile
{
    version     2.0;
    format      ascii;
    class       dictionary;
    object      blockMeshDict;
}
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

// General macros to create 2D/extruded-2D meshes

changecom(//)changequote([,])
define(calc, [esyscmd(perl -e 'print ($1)')])
define(VCOUNT, 0)
define(vlabel, [[// ]Vertex $1 = VCOUNT define($1, VCOUNT)define([VCOUNT], incr(VCOUNT))])
define(pi, 3.1415926536)
define(hex2D, hex ($1b $2b $3b $4b $1t $2t $3t $4t))

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

convertToMeters 1;

// Pipe radius (x-axis)
define(radius,0.0256)

// Pipe length (z-axis)
define(length, 3.23)

// Center (wedge) angle
define(angle, 1.0)

// Axis origin
define(x0, 0.0)
define(y0, 0.0)
define(z0, -0.20)

// Number of cells
define(nx, 30)
define(ny, 1)
define(nz, 646)

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

define(deg,calc(angle/2))
define(xx,calc(x0 + (radius*cos((pi/180)*deg))))
define(yp,calc(y0 + (radius*sin((pi/180)*deg))))
define(ym,calc(y0 - (radius*sin((pi/180)*deg))))
define(zl,calc(z0 + length))

vertices
(
    (x0 y0 z0) vlabel(a1b)
    (xx ym z0) vlabel(a2b)
    (xx yp z0) vlabel(a3b)
    (x0 y0 z0) vlabel(a4b)
    (x0 y0 zl) vlabel(a1t)
    (xx ym zl) vlabel(a2t)
    (xx yp zl) vlabel(a3t)
    (x0 y0 zl) vlabel(a4t)
);

blocks
(
    hex2D(a1, a2, a3, a4) (nx ny nz) simpleGrading (0.375 1 1)
);

edges
();

boundary
(
    inlet
    {
        type mappedPatch;
        offset          (0 0 0.1);
        sampleRegion    region0;
        sampleMode      nearestCell;
        samplePatch     none;
        faces
        (
            (a1b a4b a3b a2b)
        );
    }
    outlet
    {
        type patch;
        faces
        (
            (a1t a2t a3t a4t)
        );
    }
    walls
    {
        type wall;
        faces
        (
            (a2b a3b a3t a2t)
        );
    }
    front
    {
        type wedge;
        faces
        (
            (a1b a2b a2t a1t)
        );
    }
    back
    {
        type wedge;
        faces
        (
            (a3b a4b a4t a3t)
        );
    }
    axis
    {
        type empty;
        faces
        (
            (a4b a1b a1t a4t)
        );
    }
);

mergePatchPairs
(
);

// ************************************************************************* //
